//############################################################################
void extinction()  // Fonction pour tout éteindre
{
  Tlc.clear();
  digitalWrite(etage1, LOW);
  digitalWrite(etage2, LOW);
  digitalWrite(etage3, LOW);
  digitalWrite(etage4, LOW);
  digitalWrite(etage5, LOW);
  digitalWrite(etage6, LOW);
  digitalWrite(etage7, LOW);
  digitalWrite(etage8, LOW);
}

void extinctionTLC()
{
  for(int a=0; a<192; a++)
  {
    Tlc.set(a, 0);
    Tlc.update();
  }
}

//############################################################################
void TestEtages()  // Cette fonction test toutes les LEDs de chaque étage
{
  for(int f=0; f<8; f++)
  {
      for(int a=0; a<192; a++)
      {
        digitalWrite(etages[f], HIGH);
        Tlc.set(a, 1000);
        Tlc.update();
        delay(200);
        extinction();
      }
      extinction();
  }
}
      
//############################################################################
  void TestColonne()
  {
    
  Tlc.clear();
  for(int a=0; a<192; a++)
      {
        Tlc.set(a, 1000);
        Tlc.update();
        
  for(int a=0; a<10; a++)
  {
    digitalWrite(etage1, HIGH);
    delay(temps1);
    digitalWrite(etage1, LOW);
    digitalWrite(etage2, HIGH);
    delay(temps1);
    digitalWrite(etage2, LOW);
    digitalWrite(etage3, HIGH);
    delay(temps1);
    digitalWrite(etage3, LOW);
    digitalWrite(etage4, HIGH);
    delay(temps1);
    digitalWrite(etage4, LOW);
    digitalWrite(etage5, HIGH);
    delay(temps1);
    digitalWrite(etage5, LOW);
    digitalWrite(etage6, HIGH);
    delay(temps1);
    digitalWrite(etage6, LOW);
    digitalWrite(etage7, HIGH);
    delay(temps1);
    digitalWrite(etage7, LOW);
    digitalWrite(etage8, HIGH);
    delay(temps1);
    digitalWrite(etage8, LOW);
  }
  extinction();
      }
  Tlc.clear();
  
  }
  
//############################################################################
void aleatoire()
{
  for(int h=0; h<1500; h++)
  {
  int hasard192=random(192);
  int hasardEtage=random(8);
  
  digitalWrite(etages[hasardEtage], HIGH);
  Tlc.set(hasard192, 1000);
  Tlc.update();
  delay(10);
  Tlc.clear();
  digitalWrite(etages[hasardEtage], LOW);
  }
}
  
//############################################################################
void couleur()
{
  digitalWrite(etage8, HIGH);
  Tlc.set(0, 1000);
  Tlc.set(128, 1500);
  Tlc.update();
  delay(2000);
  Tlc.clear();
  digitalWrite(etage8, LOW);
}

//############################################################################

void TourColore()    // Programme qui alume tout le tour du cube
{
  int count;
  int tps=1;
  
  Tlc.set(56, 1000);
  Tlc.set(120, 500);
  Tlc.set(57, 600);
  Tlc.set(121, 600);
  Tlc.set(48, 1000);
  Tlc.set(112, 500);
  Tlc.set(40, 1000);
  Tlc.set(104, 500);
  Tlc.set(32, 1000);
  Tlc.set(96, 500);
  Tlc.set(58, 1000);
  Tlc.set(122, 500);
  Tlc.set(59, 1000);
  Tlc.set(123, 500);
  
  
  Tlc.set(191, 1600);
  Tlc.set(190, 1600);
  Tlc.set(183, 1600);
  Tlc.set(189, 1600);
  Tlc.set(188, 1600);
  Tlc.set(175, 1600);
  Tlc.set(167, 1600);
  
  Tlc.set(135, 500);
  Tlc.set(7, 2000);
  Tlc.set(134, 500);
  Tlc.set(6, 2000);
  Tlc.set(143, 500);
  Tlc.set(15, 2000);
  Tlc.set(151, 500);
  Tlc.set(23, 2000);
  Tlc.set(159, 500);
  Tlc.set(31, 2000);
  Tlc.set(133, 500);
  Tlc.set(5, 2000);
  Tlc.set(132, 500);
  Tlc.set(4, 2000);
  
  Tlc.set(152, 800);
  Tlc.set(144, 800);
  Tlc.set(136, 800);
  Tlc.set(128, 800);
  Tlc.set(129, 800);
  Tlc.set(130, 800);
  Tlc.set(131, 800);
  Tlc.set(88, 400);
  Tlc.set(80, 400);
  Tlc.set(72, 400);
  Tlc.set(64, 400);
  Tlc.set(65, 400);
  Tlc.set(66, 400);
  Tlc.set(67, 400);
  
  
  Tlc.update();
  
  while(count<200)      // Effet de persistence rétinienne sur tous les étages
  {
    digitalWrite(etage8, HIGH);
    delay(tps);
    digitalWrite(etage8, LOW);
    digitalWrite(etage7, HIGH);
    delay(tps);
    digitalWrite(etage7, LOW);
    digitalWrite(etage6, HIGH);
    delay(tps);
    digitalWrite(etage6, LOW);
    digitalWrite(etage5, HIGH);
    delay(tps);
    digitalWrite(etage5, LOW);
    digitalWrite(etage4, HIGH);
    delay(tps);
    digitalWrite(etage4, LOW);
    digitalWrite(etage3, HIGH);
    delay(tps);
    digitalWrite(etage3, LOW);
    digitalWrite(etage2, HIGH);
    delay(tps);
    digitalWrite(etage2, LOW);
    digitalWrite(etage1, HIGH);
    delay(tps);
    digitalWrite(etage1, LOW);
    count++;
  }
 }
 
 //############################################################################
 void LightsTest()
 {       
    int count;
    int tps=1000;          // Temps de persistence rétinienne
    
    Tlc.clear();        // On remet à zéro
    Tlc.set(8, 600);    // On allume la colonne 8
    Tlc.set(16, 600);

    Tlc.update();      // On met à jour
    
    delayMicroseconds(500);        // /!\ Petit temps pour éviter un scintillement sur les colonnes précédemment éteintes
    digitalWrite(etage7, HIGH);    // On allume et éteind les étages très rapidement pour effet de persistence rétinienne
    delayMicroseconds(tps);
    digitalWrite(etage7, LOW);
    digitalWrite(etage6, HIGH);
    delayMicroseconds(tps);
    digitalWrite(etage6, LOW);
    
    Tlc.clear();    
    Tlc.set(24, 600);
    Tlc.set(32, 600);

    Tlc.update();
    
    delayMicroseconds(500);
    digitalWrite(etage5, HIGH);
    delayMicroseconds(tps);
    digitalWrite(etage5, LOW);
    digitalWrite(etage4, HIGH);
    delayMicroseconds(tps);
    digitalWrite(etage4, LOW);
    
 }
 
 
 //############################################################################
 void Croix()
 {
   int count;
   int tps=1020;  // Meilleur temps pour éviter scintillement 1020 micro secondes
   int a=0;
   
   while(a<500)
   {
   Tlc.clear();
   Tlc.set(7, 600);
   Tlc.set(0, 600);
   Tlc.set(56, 600);
   Tlc.set(63, 600);
   Tlc.set(64, 700);
   Tlc.set(71, 700);
   Tlc.set(120, 700);
   Tlc.set(127, 700);
   Tlc.update();
   
   delayMicroseconds(500);        // /!\ Petit temps pour éviter un scintillement sur les colonnes précédemment éteintes
   digitalWrite(etage8, HIGH);    // On allume et éteind les étages très rapidement pour effet de persistence rétinienne
   delayMicroseconds(tps);
   digitalWrite(etage8, LOW);
   delayMicroseconds(500);
   digitalWrite(etage1, HIGH);
   delayMicroseconds(tps);
   digitalWrite(etage1, LOW);
   
   Tlc.clear();
   Tlc.set(73, 600);
   Tlc.set(78, 600);
   Tlc.set(113, 600);
   Tlc.set(118, 600);
   Tlc.update();
   
   delayMicroseconds(500);        // /!\ Petit temps pour éviter un scintillement sur les colonnes précédemment éteintes
   digitalWrite(etage7, HIGH);    // On allume et éteind les étages très rapidement pour effet de persistence rétinienne
   delayMicroseconds(tps);
   digitalWrite(etage7, LOW);
   digitalWrite(etage2, HIGH);
   delayMicroseconds(tps);
   digitalWrite(etage2, LOW);
   
   Tlc.clear();
   Tlc.set(18, 600);
   Tlc.set(21, 600);
   Tlc.set(42, 600);
   Tlc.set(45, 600);
   Tlc.update();
   
   delayMicroseconds(500);        // /!\ Petit temps pour éviter un scintillement sur les colonnes précédemment éteintes
   digitalWrite(etage6, HIGH);    // On allume et éteind les étages très rapidement pour effet de persistence rétinienne
   delayMicroseconds(tps);
   digitalWrite(etage6, LOW);
   digitalWrite(etage3, HIGH);
   delayMicroseconds(tps);
   digitalWrite(etage3, LOW);
   
   Tlc.clear();
   Tlc.set(155, 600);
   Tlc.set(156, 600);
   Tlc.set(163, 600);
   Tlc.set(164, 600);
   Tlc.update();
   
   delayMicroseconds(500);        // /!\ Petit temps pour éviter un scintillement sur les colonnes précédemment éteintes
   digitalWrite(etage5, HIGH);    // On allume et éteind les étages très rapidement pour effet de persistence rétinienne
   delayMicroseconds(tps);
   digitalWrite(etage5, LOW);
   delayMicroseconds(500);        // /!\ Petit temps pour éviter un scintillement sur les colonnes précédemment éteintes
   digitalWrite(etage4, HIGH);    // On allume et éteind les étages très rapidement pour effet de persistence rétinienne
   delayMicroseconds(tps);
   digitalWrite(etage4, LOW);
   
   a++;
   }
 }
 
 //############################################################################
 void ColorChange()
 {
   Tlc.clear();
   
   int rouge=0, rouge1=0, bleu=0, bleu1=0, vert=0, vert1=0;
   
   int tps=15;
   
   while(rouge1<=4000)
   {
   Tlc.set(0, rouge);
   Tlc.set(7, rouge);
   Tlc.set(56, rouge);
   Tlc.set(63, rouge);
   Tlc.update();
   digitalWrite(etage8, HIGH);
   digitalWrite(etage1, HIGH);
   delay(tps);   
   rouge+=20;
   rouge1=rouge;
   }
   
   while(rouge1>4000)
   {
     if(bleu<4000)
     {
       Tlc.set(0, rouge);
       Tlc.set(7, rouge);
       Tlc.set(56, rouge);
       Tlc.set(63, rouge);
       Tlc.set(64, bleu);
       Tlc.set(71, bleu);
       Tlc.set(120, bleu);
       Tlc.set(127, bleu);
       Tlc.update();
       digitalWrite(etage8, HIGH);
       digitalWrite(etage1, HIGH);
       delay(tps);
       rouge-=20;
       bleu+=20;
       bleu1=bleu;
     }
     
     else
     {
       rouge1=0;
     }
   }
   
   while(bleu1>=4000)
   {
     if(vert<4000)
     {
       Tlc.set(64, bleu);
       Tlc.set(71, bleu);
       Tlc.set(120, bleu);
       Tlc.set(127, bleu);
       Tlc.set(128, vert);
       Tlc.set(135, vert);
       Tlc.set(184, vert);
       Tlc.set(191, vert);       
       Tlc.update();
       digitalWrite(etage8, HIGH);
       digitalWrite(etage1, HIGH);
       delay(tps);
       bleu-=20;
       vert+=20;
       vert1=vert;
     }
     else
     {
       bleu1=0;
     }
   }
   
   while(vert1>=4000)
   {
     if(rouge<4000)
     {
       Tlc.set(128, vert);
       Tlc.set(135, vert);
       Tlc.set(184, vert);
       Tlc.set(191, vert);  
       Tlc.set(0, rouge);
       Tlc.set(7, rouge);
       Tlc.set(56, rouge);
       Tlc.set(63, rouge);
       Tlc.update();
       digitalWrite(etage8, HIGH);
       digitalWrite(etage1, HIGH);
       delay(tps);
       vert-=20;
       rouge+=20;
       rouge1=rouge;
     }
     else
     {
       vert1=0;
     }
   }
   
   while(rouge1>=4000)
   {
     if(rouge>0)
     {
       Tlc.clear();
       Tlc.set(0, rouge);
       Tlc.set(7, rouge);
       Tlc.set(56, rouge);
       Tlc.set(63, rouge);
       Tlc.update();
       digitalWrite(etage8, HIGH);
       digitalWrite(etage1, HIGH);
       delay(tps);
       rouge-=20;
     }
     else
     {
       rouge1=0;
     }
   }   
 }
